package pl.kielce.tu;

import com.sun.net.httpserver.HttpExchange;
import com.sun.net.httpserver.HttpHandler;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStream;
import java.net.URLDecoder;
import java.nio.charset.StandardCharsets;

public class FileHttpHandler implements HttpHandler {

    public void handle(HttpExchange exchange) throws IOException {
        if ("GET".equals(exchange.getRequestMethod())) {
            String requestURL = exchange.getRequestURI().toString();
            String filePath = URLDecoder.decode(requestURL.substring(1), StandardCharsets.UTF_8);
            //String filePath = URLDecoder.decode(requestURL,StandardCharsets.UTF_8);
            //filePath = filePath.substring(filePath.lastIndexOf("/"));
            String fileContent = getFileContent(filePath);
            exchange.sendResponseHeaders(200, fileContent.length());
            OutputStream stream = exchange.getResponseBody();
            stream.write(fileContent.getBytes());
            stream.close();
        }
    }

    private String getFileContent(String path) {
        StringBuilder content = new StringBuilder();
        if (path.length() != 0) {
            path = "src/main/resources/" + path;
            try (BufferedReader reader = new BufferedReader(new FileReader(path))) {
                String line;
                while ((line = reader.readLine()) != null)
                    content.append(line).append("\n");
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return content.toString();
    }
}
